# saga::advert::entry Class Reference

The advert class represents an entry in a saga::advert::directory. An advert directory is a meta data directory with a hierarchical namespace attached. This class inherits all methods from saga::name_space::namespace_entry and provides additional methods to publish new and query existing adverts. More...

`#include <advert.hpp>`

Inheritance diagram for saga::advert::entry:

[legend]

List of all members.

## Public Member Functions
| entry (saga::session const &s, saga::url url, int mode=Read)
| Constructs an advert object that points to url, opens it in mode and associates it with the session s.
| entry (saga::url url, int mode=Read)
| Constructs an advert object that points to url and opens it in mode.
| entry (saga::object const &other)
| Constructs a copy of other.
| entry (void)
| Constructs a default advert object.
| ~entry (void)
| Destroys the advert object and frees all allocated resources.
void | store_object (saga::object object)
| Stores a saga object in this advert.
template<typename T>
boost::disable_if < detail::has_sync_tag< T > >::type | store_object (T const &object)
saga::object | retrieve_object ()
| Retrieves the saga object stored in this advert.
template<typename T>
T & | retrieve_object (typename boost::disable_if< detail::has_sync_tag< T > >::type *=0)
saga::object | retrieve_object (saga::session const &s)
| Retrieves the saga object stored in this advert and associates it with the session s.
void | store_string (std::string str)
| Stores a string in this advert.
std::string | retrieve_string (void)
| Retrieves the string stored in this advert.
## Static Public Member Functions
static entry | create (session const &s, saga::url const &url, int mode=Read)
| Factory function resembling entry(session, url, int) constructor.
static entry | create (saga::url const &url, int mode=Read)
| Factory function resembling entry(url, int) constructor.
template<typename Tag>
static saga::task | create (saga::url const &url, int mode=Read)

## Detailed Description

The advert class represents an entry in a saga::advert::directory. An advert directory is a meta data directory with a hierarchical namespace attached. This class inherits all methods from saga::name_space::namespace_entry and provides additional methods to publish new and query existing adverts.

## Constructor & Destructor Documentation

saga::advert::entry::entry | ( | saga::session const & | s,
|  | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  |

Constructs an advert object that points to url, opens it in mode and associates it with the session s.

saga::advert::entry::entry | ( | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  | `[explicit]`

Constructs an advert object that points to url and opens it in mode.

saga::advert::entry::entry | ( | saga::object const & | other | ) | `[explicit]`

Constructs a copy of other.

Reimplemented from saga::name_space::entry.

References saga::object::Advert, saga::BadParameter, and saga::object::get_type().

saga::advert::entry::entry | ( | void |  | ) |

Constructs a default advert object.

Reimplemented from saga::name_space::entry.

saga::advert::entry::~entry | ( | void |  | ) |

Destroys the advert object and frees all allocated resources.

Reimplemented from saga::name_space::entry.

## Member Function Documentation

static entry saga::advert::entry::create | ( | session const & | s,
|  | saga::url const & | url,
|  | int | mode = `Read` |
| ) |  |  | `[inline, static]`

Factory function resembling entry(session, url, int) constructor.

static entry saga::advert::entry::create | ( | saga::url const & | url,
|  | int | mode = `Read` |
| ) |  |  | `[inline, static]`

Factory function resembling entry(url, int) constructor.

template<typename Tag>

static saga::task saga::advert::entry::create | ( | saga::url const & | url,
|  | int | mode = `Read` |
| ) |  |  | `[inline, static]`

void saga::advert::entry::store_object | ( | saga::object | object | ) | `[inline]`

Stores a saga object in this advert.

Parameters:

  | object | The object to store

template<typename T>

boost::disable_if<detail::has_sync_tag<T> >::type saga::advert::entry::store_object | ( | T const & | object | ) | `[inline]`

saga::object saga::advert::entry::retrieve_object | ( |  | ) | `[inline]`

Retrieves the saga object stored in this advert.

Returns:
  The object stored in this advert

template<typename T>

T& saga::advert::entry::retrieve_object | ( | typename boost::disable_if< detail::has_sync_tag< T > >::type * | = `0` | ) | `[inline]`

saga::object saga::advert::entry::retrieve_object | ( | saga::session const & | s | ) | `[inline]`

Retrieves the saga object stored in this advert and associates it with the session s.

Parameters:

  | s | a session object

Returns:
  The object stored in this advert

void saga::advert::entry::store_string | ( | std::string | str | ) | `[inline]`

Stores a string in this advert.

obsolete API below, don't use this anymore

Parameters:

  | str | The string to store

References saga::task::get_result().

std::string saga::advert::entry::retrieve_string | ( | void |  | ) | `[inline]`

Retrieves the string stored in this advert.

Returns:
  The string stored in this advert

The documentation for this class was generated from the following files:

- packages/advert/advert.hpp
- advert.cpp